; Atome77 v1.01 (c)2000 par Denis SANCHEZ
; version TI-83 Plus

;Les infos passent par le bit 0 (bout du jack)
;!!!!!!!!!! Attention logique inverse !!!!!!!!!!
; => le signal d'entre est invers (collecteur ouvert du module DCF77)
;    donc si sur le port 7 on a un 0 on rceptionne en fait un 1

;pour tre compatible avec le shell ION, il suffit de rajouter la ligne suivante :
;#DEFINE SHELL

;si la ligne qui suit n'est pas en commentaire : le programme est en mode calibration.
;cd au lieu d'afficher les infos horaire, il affiche l'tat des registres de mesure des temps
;HL -> dure de la priode
;DE -> dure de l'tat bas
;BC -> dure de l'tat haut
;#DEFINE TEST

#DEFINE TI83P
#INCLUDE "ion.inc"

;------------------------------ Zone des constantes ------------------------------

C_PORT_LINK	= 0						;numro port du "LINK"
C_11			= $C0						;code correspondant au %11
K_EXIT		= $37						;sur la TI83 c'est MODE

;------------------------------ Zone d'initialisation ------------------------------


.org    progstart-2
	.db $BB,$6D

#IFDEF SHELL
	ret
	jr nc,debut
Nomprog:
	.db "Atome77 v1.01",0
#ENDIF

debut:
	ld A,C_11
	out (C_PORT_LINK),A				;les 2 bits du cble  +5V (pour pouvoir reevoir les infos)

;------------------------------ Zone du programme ------------------------------

	bcall(_clrlcdf)					;ecran effac
	bcall(_indicatorOff)				;pas de d'indicateur en haut  gauche

	ld HL,$0100							;affichage auteur & (c)
	ld (currow),HL
	ld HL,Nomprog
	bcall(_puts)
	ld HL,$0301
	ld (currow),HL
	ld HL,CopyRight
	bcall(_puts)
	ld HL,$0102
	ld (currow),HL
	ld HL,Auteur
	bcall(_puts)

sec59:
	ld HL,Recherche59
	ld (TXT),HL
debboucle:
	ld A,1								;initialisation du compteur de seconde
											;A est  1 car le bit 0 vient dj d'tre reu
											;(2 secondes entre le bit 58 et le bit 0)
											;le bit 0 n'avait pas besoin d'tre sauv, il est toujours  0
	ld (SEC),A
boucle:
;********** rception du bit **********
	call getbit


#IFDEF TEST
	push HL
	push DE
	push BC
	push BC
	push DE
	push HL
	ld HL,$0004
	ld (currow),HL
	pop HL								;prparation de HL
	bcall(_disphl)
	ld HL,$0005
	ld (currow),HL
	pop HL								;prparation de DE
	bcall(_disphl)
	ld HL,$0006
	ld (currow),HL
	pop HL								;prparation de BC
	bcall(_disphl)
	pop BC
	pop DE
	pop HL
#ENDIF


	push HL								;sauvegarde du temps entre 2 fronts montants

;********** on sauve le bit reu en mmoire **********
	push AF								;on sauve le bit reu
	ld A,(SEC)
	srl A
	srl A
	srl A									;A vient d'tre divis par 8 (bit -> octet)
	ld D,0
	ld E,A								;adresse relative de la trame dans DE
	ld HL,TRAME
	add HL,DE							;adresse effective de la trame dans HL
	pop AF								;on recupre A et donc le bit reu
	push AF								;on sauve de nouveau A
	rra									;on met le bit reu dans Carry (cette instruction prend 1 octet
											;contrairement  srl A qui en prend 2)
	rr (HL)								;le bit est sauv (le premier bit  tre sauv est de poids
											;faible => rotation  droite

;********** affichage du bit **********
	pop AF								;on recupre de nouveau A
	cp 2
	jr c,boucle2						;si le bit reu est indtermin, on recommence depuis le
											;dbut (A>=2)
	pop HL								;il faut vider la pile
	jr sec59
boucle2:
	add A,'0'							;conversion en ASCII
#IFNDEF TEST
	ld HL,$0F04							;affichage de l'tat du port  l'cran
	ld (currow),HL
	bcall(_putc)
	ld HL,$0904							;affichage du numro du bit
	ld (currow),HL
	ld A,(SEC)
	ld L,A
	ld H,0
	ld A,0
	bcall(_disphl)
	ld HL,$0004							;affichage du texte de dscription ("Bit n=" ou "59me sec")
	ld (currow),HL
	ld HL,(TXT)
	bcall(_puts)
	ld HL,$0E04							;affichage du =
	ld (currow),HL
	ld A,'='
	bcall(_putc)
#ENDIF

;********** n bit & 59me seconde **********
	ld HL,SEC
	inc (HL)
	ld A,59
	cp (HL)								;si le prochain bit est le 59, on le change en 0 (y'a pas de 59)
	jr nz,boucle3
	ld (HL),0
boucle3:
	pop HL								;dure entre 2 fronts montants
	ld DE,1750							;on fera le test avec 1750 ms (2 secondes pour 58->0)
	bcall(_cphlde)
	jp c,boucle							;si il n'y a pas de saut => 59me seconde
											;il faut alors vrifier que le compteur se trouve bien 
											;la 60me seconde (60 veut dire que la 59me vient d'tre
											;passe)
	ld A,(SEC)
	cp 1
	jp nz,sec59							;on fait le saut si le comteur n'tait pas  1
	ld HL,Etatbit
	ld (TXT),HL							;affichage de "Bit n??="
											;on vient de reevoir une trame sans problme, on peut donc
											;afficher les infos (date, heure ...)

	ld HL,TRAME+7						;le dernier octet n'est pas compltement remplie (59 bit au
											;lieu de 64. on va donc le remplir de 0 (sinon il y a un dcalage
											;des bits reus)
	ld A,0
	rrd
	srl (HL)								;dcalage de 5 bits  droite

	;********** jour de la semaine **********
	ld HL,0006
	ld (currow),HL
	ld D,0
	ld A,(TRAME+5)
	and %00011100
	ld E,A
	ld HL,Jours-4
	add HL,DE
	bcall(_puts)

	;********** date **********
	ld HL,curcol
	inc (HL)
	ld A,40
	ld C,41
	call affbcd
	ld A,36
	call affbcd
	ld A,'/'
	bcall(_putc)
	ld A,49
	ld C,A
	call affbcd
	ld A,45
	call affbcd
	ld HL,Annee20
	bcall(_puts)
	ld A,54
	ld C,57
	call affbcd
	ld A,50
	call affbcd

	;********** parit date ok ? (P3) **********
	ld C,36
	ld A,58
	call parite
	jr z,P3
	ld HL,0006
	ld (currow),HL
	ld HL,ErrDate
	bcall(_puts)
P3:

	;********** heure & minute **********
	ld HL,0007
	ld (currow),HL
	ld A,33
	ld C,34
	call affbcd
	ld A,29
	call affbcd
	;********** parit heure ok ? (P2) **********
	ld C,29
	ld A,35
	call parite
	jr z,P2
	ld HL,0007
	ld (currow),HL
	ld HL,ErrTime
	bcall(_puts)
P2:
	ld A,':'
	bcall(_putc)
	ld A,25
	ld C,27
	call affbcd
	ld A,21
	call affbcd
	;********** parit minute ok ? (P1) **********
	ld C,21
	ld A,28
	call parite
	jr z,P1
	ld HL,0307
	ld (currow),HL
	ld HL,ErrTime
	bcall(_puts)
P1:

	jp debboucle


;------------------------------ Zone des sous-programmes ------------------------------
;***********************************************************
;** test si la parit d'un groupe de bits est correcte    **
;** Entre : C bit de dpart, A bit de fin (inclu)        **
;** Sortie : Zero=0 si parit correcte, C=A+1, B=?, HL=?? **
;***********************************************************
parite:
	ld B,0								;initialisation du "compteur de parit"
											;(il comptera les bits  1)
parite2:
	push AF								;sauvegarde de A (il est modifi dans call testbit)
	call testbit
	jr z,parite3
	inc B									;si le bit tait  1 => B=B+1
parite3:
	inc C									;bit suivant
	pop AF								;on rcupre A
	cp C
	jr nc,parite2
	bit 0,B								;si le bit 0 de B est  0 => parit paire
	ret


;**********************************************************************************
;** Affiche le quartet en BCD sur la position courante du curseur et l'actualise **
;** Entre : curseur (currow), A bit de dpart, C bit de fin (inclu)            **
;** Sortie : colonne du curseur incrment, C=A-1, B=?                           **
;**********************************************************************************
affbcd:
	ld B,0								;initialisation du futur code BCD => ASCII
	dec A
affbcd2:
	push AF								;sauvegarde de A (il est modifi dans call testbit)
	call testbit
	jr nz,affbcd3
	sla B
	jr affbcd4
affbcd3:
	scf									;Carry est mis  1
	rl B
affbcd4:
	pop AF								;on rcupre le bit de dbut
	dec C									;bit suivant
	cp C									;et on compare au bit actuel
	jr c,affbcd2						;si le bit de dpart est >= au bit d'arrive => boucle finie
	ld A,B
	add A,'0'							;conversion BCD -> ASCII
	bcall(_putc)
	ret


;*****************************************************************
;** Test le bit N C                                            **
;** Entre : C (numro du bit  tester)                         **
;** Sortie : Zero=tat du bit test, A=?, HL=adresse de l'octet **
;*****************************************************************
testbit:
	push BC
	ld A,0
	srl C
	rra
	srl C
	rra
	srl C									;C vient d'tre divis par 8 (bit -> octet)
	rra
	rra
	rra									;ici A=8*le bit  traiter
	add A,$46							;on transforme la constant (bit ->0<-,(HL)) en variable
	ld HL,TRAME
	ld B,0
	add HL,BC							;dans HL il y a l'adresse effective de l'octet qui contient
											;le bit  traiter
	ld (testbit2+1),A
testbit2:
	bit 0,(HL)							;opcode : $CB $46+8*b
											;on test le bit
	pop BC
	ret


;*********************************************************************************************
;** C=0 front descendant, C=1 front montant                                                 **
;** Entre : -                                                                              **
;** Sortie : temps d'attente en psedo-ms: HL entre chaque bit, BC dure du 1, DE dure du 0 **
;**          A contient le bit reu (si A=$FF problme sur le niveau haut HL<55 ou HL>255)  **
;*********************************************************************************************
getbit:
	ld C,1								;on attend un front montant
	call waitbit
	ld D,H
	ld E,L
	ld C,0								;on attend un front descendant
	call waitbit
	ld B,H
	ld C,L
	add HL,DE							;on a dans HL la dure totale
	ld A,0
	cp B									;B=0 ?
	jr nz,getbit3						;si B<>0 => BC>255 => impulsion de 200ms trop grande
	ld A,155								;limite max pour l'impulsion de 100ms (niveau logique 0)
	cp C
	jr nc,getbit2
	inc A
getbit2:
	sub 154								;si C<=155 alors A=1 sinon A=2 (A sera dcrment  la fin)
	push DE								;on sauve DE pour sauver ensuite A dans D
	ld D,A
	ld A,55								;limite min pour l'impulsion de 100ms (niveau logique 0)
	cp C
	ld A,D								;on rcupre A (le flag Carry n'est pas modifi par un ld A,)
	pop DE								;puis DE
	jr c,getbit3
	ld A,0								;y'a un prob (BC<55ms)
getbit3:
	dec A
	ret


;*******************************************************
;** C=0 front descendant, C=1 front montant           **
;** Entre : C                                        **
;** Sortie : HL temps d'attente en psedo-milliseconde **
;** Modif  : A=?,B=?                                  **
;*******************************************************
waitbit:
	ld HL,0								;initialisation du compteur principal
waitbit1:
	ld B,250								;initialisation du compteur secondaire
	inc HL								;le 250 est choisi pour avoir HL en milliseconde
	ld A,H
	or L
	jr z,resetprog						;si HL passe  "0" => dbordement => problme => reset du prog
waitbit2:
	inc B
	jr z,waitbit1
	in A,(C_PORT_LINK)				;saisie des donnes sur le port
	and %00000001						;on isole le bit 0
	xor C
	ret nz								;si le front souhait est l on quitte le sous-programme
											;sinon on continue la boucle et on test EXIT
	push HL
	bcall(_GetK)						;code touche
	pop HL
	cp K_EXIT							;on peut quitter le prog avec EXIT
	jr nz,waitbit2


;***********************************************************
;** pour quitter le programme dans un sous-sous-programme **
;***********************************************************
retsp:									;pour quitter dans un sous-programme
											;il va faire SP=SP-4 (comme un ret) => 4 ret => TI-OS
	inc SP
	inc SP
	inc SP
	inc SP
quitter:									;pour quitter
	bcall(_clrscrf)					;efface l'cran
	bcall(_homeup)						;curseur en haut  gauche
	ret


;**************************************************************
;** pour redmarrer le programme dans un sous-sous-programme **
;**************************************************************
resetprog:
	inc SP
	inc SP
	inc SP
	inc SP
	jp sec59


;------------------------------ Zone des donnes ------------------------------

#IFNDEF SHELL
Nomprog:
	.db "Atome77 v1.01",0
#ENDIF
CopyRight:
	.db "(c)2000",0
Auteur:
	.db "Denis SANCHEZ",0
Recherche59:
	.db "59",151,"me sec",$CE," ",$1C,0
Etatbit:
	.db "      bit n",$14,0
Annee20:
	.db "/20",0
Jours:
	.db "Lun",0
	.db "Mar",0
	.db "Mer",0
	.db "Jeu",0
	.db "Ven",0
	.db "Sam",0
	.db "Dim",0
ErrDate:
	.db "??? ??/??/????",0
ErrTime:
	.db "??",0
SEC:
	.db 0
TXT:
	.db 0,0
TRAME:
	.db 0,0,0,0,0,0,0,0				;pour stocker les 59 bits (64 max)

.end
